var c = Object.defineProperty;
var m = (t, e, r) => e in t ? c(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r;
var o = (t, e, r) => m(t, typeof e != "symbol" ? e + "" : e, r);
var u = /* @__PURE__ */ ((t) => (t.PRIVATE = "WALLET", t.VASP = "VASP", t))(u || {}), E = /* @__PURE__ */ ((t) => (t.NATURAL = "natural", t.LEGAL = "legal", t.SELF = "self", t))(E || {}), p = /* @__PURE__ */ ((t) => (t.EMPTY = "empty", t.VERIFY = "verify", t.PENDING = "pending", t.VERIFIED = "verified", t.BANNED = "banned", t))(p || {}), f = /* @__PURE__ */ ((t) => (t.ASSET = "asset", t.DESTINATION = "destination", t.COUNTERPARTY = "counterparty", t.AGENT = "agent", t))(f || {}), a = /* @__PURE__ */ ((t) => (t.COMPLETE = "complete", t.RESIZE = "resize", t.RESULT = "result", t.READY = "ready", t.INVALID = "invalid", t.ERROR = "error", t.CANCEL = "cancel", t))(a || {}), d = /* @__PURE__ */ ((t) => (t.UPDATE = "update", t.REQUEST_RESPONSE = "requestResponse", t))(d || {}), g = /* @__PURE__ */ ((t) => (t.PENDING = "pending", t.FAILED = "rejected", t.FLAGGED = "flagged", t.VERIFIED = "verified", t))(g || {}), v = /* @__PURE__ */ ((t) => (t.SelfDeclaration = "self-declaration", t.SIWE = "siwe", t.SIWX = "siwx", t.EIP191 = "eip-191", t.EIP712 = "eip-712", t.EIP1271 = "eip-1271", t.BIP137 = "bip-137", t.BIP137_XPUB = "xpub", t.ED25519 = "ed25519", t.MicroTransfer = "microtransfer", t.Screenshot = "screenshot", t))(v || {});
class I {
  constructor() {
    o(this, "listeners", /* @__PURE__ */ new Map());
    o(this, "port");
    this.handleMessage = this.handleMessage.bind(this);
  }
  /**
   * Sets up the message port for communication.
   *
   * Initializes the MessagePort for receiving messages by setting up the message handler
   * and starting the port.
   *
   * @param port - The MessagePort instance to use for communication
   */
  setPort(e) {
    this.port = e, this.port.onmessage = this.handleMessage, this.port.start();
  }
  /**
   * Registers a callback for a specific message type.
   *
   * When messages of the specified type are received, the callback will be executed
   * with the message data.
   *
   * @param messageType - The type of message to listen for
   * @param callback - The callback function to execute when matching messages are received
   */
  on(e, r) {
    this.listeners.has(e) || this.listeners.set(e, /* @__PURE__ */ new Set()), this.listeners.get(e).add(r);
  }
  /**
   * Removes a callback for a specific message type.
   *
   * If the callback is the last one registered for the message type,
   * the message type entry will be removed entirely.
   *
   * @param messageType - The type of message to remove listener from
   * @param callback - The callback function to remove
   */
  off(e, r) {
    const s = this.listeners.get(e);
    s && (s.delete(r), s.size === 0 && this.listeners.delete(e));
  }
  /**
   * Internal message handler for processing received messages.
   *
   * Validates incoming messages and dispatches them to registered callbacks
   * based on the message type.
   *
   * @param event - The message event containing the component message
   */
  handleMessage(e) {
    const r = e.data;
    if (typeof r == "object" && r !== null && "type" in r) {
      const s = r.type, i = this.listeners.get(s);
      i && i.forEach((n) => n(r));
    }
  }
  /**
   * Sends a message through the message port
   * @param message The host message to send
   */
  send(e) {
    this.port && this.port.postMessage(e);
  }
}
class w {
  /**
   * Creates an instance of EmbeddedComponent.
   * @param url - The URL of the embedded component
   * @param value - The initial transaction value
   */
  constructor(e, r, s) {
    o(this, "_url");
    o(this, "_value");
    o(this, "_options");
    o(this, "_errors", []);
    o(this, "iframe");
    o(this, "eventManager");
    o(this, "modal");
    this._url = e, this._value = r, this._options = s, this.eventManager = new I(), this.on(a.INVALID, (i) => {
      i.type === a.INVALID && (this._errors = i.errors, this._value = i.value);
    }), this.on(a.RESIZE, (i) => {
      i.type === a.RESIZE && this.iframe && (this.iframe.style.height = `${i.height}px`);
    });
  }
  /**
   * Gets the URL of the embedded component
   * @returns The URL of the embedded component
   */
  get url() {
    return this._url;
  }
  /**
   * Gets the current transaction value
   * @returns The current transaction value
   */
  get value() {
    return this._value;
  }
  get options() {
    return this._options;
  }
  get errors() {
    return this._errors;
  }
  /**
   * Opens the component URL in the current window
   */
  open() {
    document.location.href = this.url;
  }
  /**
   * Mounts the component to a parent element
   * @param parentId - The ID of the parent element
   * @throws Will throw an error if the parent element is not found
   */
  mount(e) {
    const r = document.querySelector(e);
    if (!r) throw new Error(`parentID ${e} not found`);
    this.embed(r);
  }
  /**
   * Embeds the component into a parent element
   * @param parent - The parent element to embed the component into
   */
  embed(e, r = !1) {
    var s, i;
    this.removeEmbed(), this.iframe = document.createElement("iframe"), this.iframe.src = this.url + (r ? "" : "&embedded=true"), this.iframe.allow = "web-share", this.iframe.style.width = "100%", this.iframe.style.height = "100px", this.iframe.style.border = "none", this.iframe.style.overflow = "hidden", e.appendChild(this.iframe), window.addEventListener("message", (n) => {
      var h, l;
      n.source === ((h = this.iframe) == null ? void 0 : h.contentWindow) && ((l = this.eventManager) == null || l.setPort(n.ports[0]));
    }), (i = (s = this.iframe) == null ? void 0 : s.contentWindow) == null || i.focus();
  }
  removeEmbed() {
    this.iframe && this.iframe.remove();
  }
  /**
   * Sends a message to the embedded component
   * @param message - The message to send
   */
  send(e) {
    this.eventManager.send(e);
  }
  /**
   * Adds an event listener for a specific message type
   * @param messageType - The type of message to listen for
   * @param callback - The callback function to execute when the message is received
   */
  on(e, r) {
    this.eventManager.on(e, r);
  }
  /**
   * Removes an event listener for a specific message type
   * @param messageType - The type of message to stop listening for
   * @param callback - The callback function to remove
   */
  off(e, r) {
    this.eventManager.off(e, r);
  }
  /**
   * Updates the transaction value and sends an update message to the component
   * @param value - The new transaction value
   */
  update(e, r) {
    this._value = e, r && (this._options = r), this.send({ type: d.UPDATE, value: e, options: this._options });
  }
  /**
   * Waits for the component to complete and returns the transaction response
   * @returns A promise that resolves with the transaction response
   */
  completion() {
    return new Promise((e, r) => {
      this.on(a.COMPLETE, (s) => {
        e(s.response);
      }), this.on("error", (s) => {
        r(new Error(s.message));
      });
    });
  }
  /**
   * Opens the component in a modal dialog
   */
  openModal() {
    return this.modal && this.closeModal(), this.modal = document.createElement("dialog"), this.modal.style.border = "none", this.modal.style.backgroundColor = "white", this.modal.style.maxWidth = "100vw", this.modal.style.maxHeight = "100vh", this.modal.style.width = "600px", this.modal.style.height = "600px", document.body.appendChild(this.modal), this.embed(this.modal, !0), this.on(a.CANCEL, () => {
      this.closeModal();
    }), this.on(a.COMPLETE, () => {
      this.closeModal();
    }), this.modal.showModal(), this.modal.addEventListener("click", () => {
      this.closeModal();
    }), this.completion();
  }
  /**
   * Closes the modal dialog
   *
   */
  closeModal() {
    var e;
    this.modal && ((e = this.modal) == null || e.close(), this.modal.remove(), this.modal = void 0);
  }
}
function U(t) {
  return Object.entries(t).map(([e, r]) => {
    if (!(e && r)) return;
    const s = encodeURIComponent(e), i = encodeURIComponent(
      typeof r == "object" ? JSON.stringify(r) : r
    );
    return `${s}=${i}`;
  }).filter((e) => !!e).join("&");
}
class b {
  /**
   * Creates a new instance of the Notabene SDK
   *
   * @param config - Configuration options for the Notabene SDK
   */
  constructor(e) {
    o(this, "nodeUrl");
    o(this, "authToken");
    o(this, "uxUrl");
    o(this, "theme");
    o(this, "locale");
    this.uxUrl = e.uxUrl || "https://connect.notabene.id", this.nodeUrl = e.nodeUrl, this.authToken = e.authToken, this.theme = e.theme, this.locale = e.locale;
  }
  /**
   * Generates a URL for a Notabene component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param configuration - Optional transaction configuration
   * @param callbacks - Optional callback configuration
   * @returns component URL
   * @internal
   */
  componentUrl(e, r, s, i) {
    const n = new URL(this.uxUrl);
    n.pathname = e;
    const h = U({
      authToken: this.authToken,
      value: r,
      configuration: s
    });
    return n.hash = h, this.nodeUrl && n.searchParams.set("nodeUrl", this.nodeUrl), this.theme && n.searchParams.set("theme", JSON.stringify(this.theme)), this.locale && n.searchParams.set("locale", this.locale), i && (i.callback && n.searchParams.set("callback_url", i.callback), i.redirectUri && n.searchParams.set("redirect_uri", i.redirectUri)), n.toString();
  }
  /**
   * Creates a new embedded component
   *
   * @param path - The path of the component
   * @param value - Transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance
   * @internal
   */
  createComponent(e, r, s, i) {
    return new w(
      this.componentUrl(e, r, s, i),
      r,
      s
    );
  }
  /**
   * Creates a withdrawal assist component
   *
   * @param value - Withdrawal transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for withdrawal assistance
   */
  createWithdrawalAssist(e, r, s) {
    return this.createComponent(
      "withdrawal-assist",
      e,
      r,
      s
    );
  }
  /**
   * Creates a deposit assist component
   *
   * @param value - Deposit transaction data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit assistance
   * @alpha
   */
  createDepositAssist(e, r, s) {
    return this.createComponent(
      "deposit-assist",
      e,
      r,
      s
    );
  }
  /**
   * Creates a connect component
   *
   * @param value - Connection request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for connection
   * @alpha
   */
  createConnectWallet(e, r, s) {
    return this.createComponent(
      "connect",
      e,
      r,
      s
    );
  }
  /**
   * Creates a deposit request component
   *
   * @param value - Deposit request data
   * @param options - Optional transaction options
   * @param callbacks - Optional callback configuration
   * @returns A new EmbeddedComponent instance for deposit requests
   * @public
   */
  createDepositRequest(e, r, s) {
    return this.createComponent(
      "deposit-request",
      e,
      r,
      s
    );
  }
  /**
   * Decodes a URL fragment into an object
   *
   * @param fragment - The URL fragment to decode
   * @returns An object containing the decoded key-value pairs
   */
  decodeFragmentToObject(e) {
    return e.slice(1).split("&").reduce(
      (s, i) => {
        const [n, h] = i.split("=");
        return s[decodeURIComponent(n)] = decodeURIComponent(h), s;
      },
      {}
    );
  }
}
export {
  u as AgentType,
  a as CMType,
  w as EmbeddedComponent,
  d as HMType,
  E as PersonType,
  g as ProofStatus,
  v as ProofTypes,
  p as Status,
  f as ValidationSections,
  b as default
};
